## Tool: `get_spec`

Get details about a spec resource in the API hub.

The following sample demonstrate how to use `curl` to invoke the `get_spec` MCP tool.

| Curl Request |
|---|
| ```bash curl --location 'https://apihub.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "get_spec", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' ``` |

## Input Schema

The `GetSpec` method's request.

### GetSpecRequest

| JSON representation |
|---|
| ``` { "name": string } ``` |

| Fields ||
|---|---|
| `name` | `string` Required. The name of the spec to retrieve. Format: `projects/{project}/locations/{location}/apis/{api}/versions/{version}/specs/{spec}` |

## Output Schema

Represents a spec associated with an API version in the API Hub. Note that specs of various types can be uploaded, however parsing of details is supported for OpenAPI spec currently.

### Spec

| JSON representation |
|---|
| ``` { "name": string, "displayName": string, "specType": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, "contents": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SpecContents`) }, "details": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SpecDetails`) }, "sourceUri": string, "createTime": string, "updateTime": string, "lintResponse": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.LintResponse`) }, "attributes": { string: { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, ... }, "documentation": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.Documentation`) }, "parsingMode": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.ParsingMode`), "sourceMetadata": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceMetadata`) } ], "additionalSpecContents": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.AdditionalSpecContent`) } ] } ``` |

| Fields ||
|---|---|
| `name` | `string` Identifier. The name of the spec. Format: `projects/{project}/locations/{location}/apis/{api}/versions/{version}/specs/{spec}` |
| `displayName` | `string` Required. The display name of the spec. This can contain the file name of the spec. |
| `specType` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` Required. The type of spec. The value should be one of the allowed values defined for `projects/{project}/locations/{location}/attributes/system-spec-type` attribute. The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. Note, this field is mandatory if content is provided. |
| `contents` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SpecContents`)`` Optional. Input only. The contents of the uploaded spec. |
| `details` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SpecDetails`)`` Output only. Details parsed from the spec. |
| `sourceUri` | `string` Optional. The URI of the spec source in case file is uploaded from an external version control system. |
| `createTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the spec was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `updateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the spec was last updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `lintResponse` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.LintResponse`)`` Optional. The lint response for the spec. |
| `attributes` | ``map (key: string, value: object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`))`` Optional. The list of user defined attributes associated with the spec. The key is the attribute name. It will be of the format: `projects/{project}/locations/{location}/attributes/{attribute}`. The value is the attribute values associated with the resource. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `documentation` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.Documentation`)`` Optional. The documentation of the spec. For OpenAPI spec, this will be populated from `externalDocs` in OpenAPI spec. |
| `parsingMode` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.ParsingMode`)`` Optional. Input only. Enum specifying the parsing mode for OpenAPI Specification (OAS) parsing. |
| `sourceMetadata[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceMetadata`)`` Output only. The list of sources and metadata from the sources of the spec. |
| `additionalSpecContents[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.AdditionalSpecContent`)`` Output only. The additional spec contents for the spec. |

### AttributeValues

| JSON representation |
|---|
| ``` { "attribute": string, // Union field `Value` can be only one of the following: "enumValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.EnumAttributeValues`) }, "stringValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) }, "jsonValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) }, "uriValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) } // End of list of possible types for union field `Value`. } ``` |

| Fields ||
|---|---|
| `attribute` | `string` Output only. The name of the attribute. Format: projects/{project}/locations/{location}/attributes/{attribute} |
| Union field `Value`. The attribute values associated with the resource. `Value` can be only one of the following: ||
| `enumValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.EnumAttributeValues`)`` The attribute values associated with a resource in case attribute data type is enum. |
| `stringValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is string. |
| `jsonValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is JSON. |
| `uriValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is URL, URI or IP, like gs://bucket-name/object-name. |

### EnumAttributeValues

| JSON representation |
|---|
| ``` { "values": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AllowedValue`) } ] } ``` |

| Fields ||
|---|---|
| `values[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AllowedValue`)`` Required. The attribute values in case attribute data type is enum. |

### AllowedValue

| JSON representation |
|---|
| ``` { "id": string, "displayName": string, "description": string, "immutable": boolean } ``` |

| Fields ||
|---|---|
| `id` | `string` Required. The ID of the allowed value. \* If provided, the same will be used. The service will throw an error if the specified id is already used by another allowed value in the same attribute resource. \* If not provided, a system generated id derived from the display name will be used. In this case, the service will handle conflict resolution by adding a system generated suffix in case of duplicates. This value should be 4-63 characters, and valid characters are /\[a-z\]\[0-9\]-/. |
| `displayName` | `string` Required. The display name of the allowed value. |
| `description` | `string` Optional. The detailed description of the allowed value. |
| `immutable` | `boolean` Optional. When set to true, the allowed value cannot be updated or deleted by the user. It can only be true for System defined attributes. |

### StringAttributeValues

| JSON representation |
|---|
| ``` { "values": [ string ] } ``` |

| Fields ||
|---|---|
| `values[]` | `string` Required. The attribute values in case attribute data type is string or JSON. |

### SpecContents

| JSON representation |
|---|
| ``` { "contents": string, "mimeType": string } ``` |

| Fields ||
|---|---|
| `contents` | `string (https://developers.google.com/discovery/v1/type-format format)` Required. The contents of the spec. A base64-encoded string. |
| `mimeType` | `string` Required. The mime type of the content for example application/json, application/yaml, application/wsdl etc. |

### SpecDetails

| JSON representation |
|---|
| ``` { "description": string, // Union field `details` can be only one of the following: "openApiSpecDetails": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.OpenApiSpecDetails`) } // End of list of possible types for union field `details`. } ``` |

| Fields ||
|---|---|
| `description` | `string` Output only. The description of the spec. |
| Union field `details`. `details` can be only one of the following: ||
| `openApiSpecDetails` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.OpenApiSpecDetails`)`` Output only. Additional details apart from `OperationDetails` parsed from an OpenAPI spec. The OperationDetails parsed from the spec can be obtained by using `ListAPIOperations` method. |

### OpenApiSpecDetails

| JSON representation |
|---|
| ``` { "format": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Format`), "version": string, "owner": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.Owner`) } } ``` |

| Fields ||
|---|---|
| `format` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Format`)`` Output only. The format of the spec. |
| `version` | `string` Output only. The version in the spec. This maps to `info.version` in OpenAPI spec. |
| `owner` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.Owner`)`` Output only. Owner details for the spec. This maps to `info.contact` in OpenAPI spec. |

### Owner

| JSON representation |
|---|
| ``` { "displayName": string, "email": string } ``` |

| Fields ||
|---|---|
| `displayName` | `string` Optional. The name of the owner. |
| `email` | `string` Required. The email of the owner. |

### Timestamp

| JSON representation |
|---|
| ``` { "seconds": string, "nanos": integer } ``` |

| Fields ||
|---|---|
| `seconds` | `string (https://developers.google.com/discovery/v1/type-format format)` Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
| `nanos` | `integer` Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |

### LintResponse

| JSON representation |
|---|
| ``` { "issues": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Issue`) } ], "summary": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SummaryEntry`) } ], "state": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.LintState`), "source": string, "linter": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Linter`), "createTime": string } ``` |

| Fields ||
|---|---|
| `issues[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Issue`)`` Optional. Array of issues found in the analyzed document. |
| `summary[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SummaryEntry`)`` Optional. Summary of all issue types and counts for each severity level. |
| `state` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.LintState`)`` Required. Lint state represents success or failure for linting. |
| `source` | `string` Required. Name of the linting application. |
| `linter` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Linter`)`` Required. Name of the linter used. |
| `createTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Required. Timestamp when the linting response was generated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |

### Issue

| JSON representation |
|---|
| ``` { "code": string, "path": [ string ], "message": string, "severity": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Severity`), "range": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Range`) } } ``` |

| Fields ||
|---|---|
| `code` | `string` Required. Rule code unique to each rule defined in linter. |
| `path[]` | `string` Required. An array of strings indicating the location in the analyzed document where the rule was triggered. |
| `message` | `string` Required. Human-readable message describing the issue found by the linter. |
| `severity` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Severity`)`` Required. Severity level of the rule violation. |
| `range` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Range`)`` Required. Object describing where in the file the issue was found. |

### Range

| JSON representation |
|---|
| ``` { "start": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Point`) }, "end": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Point`) } } ``` |

| Fields ||
|---|---|
| `start` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Point`)`` Required. Start of the issue. |
| `end` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Point`)`` Required. End of the issue. |

### Point

| JSON representation |
|---|
| ``` { "line": integer, "character": integer } ``` |

| Fields ||
|---|---|
| `line` | `integer` Required. Line number (zero-indexed). |
| `character` | `integer` Required. Character position within the line (zero-indexed). |

### SummaryEntry

| JSON representation |
|---|
| ``` { "severity": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Severity`), "count": integer } ``` |

| Fields ||
|---|---|
| `severity` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.Severity`)`` Required. Severity of the issue. |
| `count` | `integer` Required. Count of issues with the given severity. |

### AttributesEntry

| JSON representation |
|---|
| ``` { "key": string, "value": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) } } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` |

### Documentation

| JSON representation |
|---|
| ``` { "externalUri": string } ``` |

| Fields ||
|---|---|
| `externalUri` | `string` Optional. The uri of the externally hosted documentation. |

### SourceMetadata

| JSON representation |
|---|
| ``` { "sourceType": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceType`), "originalResourceId": string, "originalResourceCreateTime": string, "originalResourceUpdateTime": string, // Union field `source` can be only one of the following: "pluginInstanceActionSource": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.PluginInstanceActionSource`) } // End of list of possible types for union field `source`. } ``` |

| Fields ||
|---|---|
| `sourceType` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceType`)`` Output only. The type of the source. |
| `originalResourceId` | `string` Output only. The unique identifier of the resource at the source. |
| `originalResourceCreateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the resource was created at the source. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `originalResourceUpdateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the resource was last updated at the source. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| Union field `source`. The source of the resource. `source` can be only one of the following: ||
| `pluginInstanceActionSource` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.PluginInstanceActionSource`)`` Output only. The source of the resource is a plugin instance action. |

### PluginInstanceActionSource

| JSON representation |
|---|
| ``` { "pluginInstance": string, "actionId": string } ``` |

| Fields ||
|---|---|
| `pluginInstance` | `string` Output only. The resource name of the source plugin instance. Format is `projects/{project}/locations/{location}/plugins/{plugin}/instances/{instance}` |
| `actionId` | `string` Output only. The id of the plugin instance action. |

### AdditionalSpecContent

| JSON representation |
|---|
| ``` { "specContentType": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SpecContentType`), "specContents": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SpecContents`) }, "createTime": string, "updateTime": string, "labels": { string: string, ... } } ``` |

| Fields ||
|---|---|
| `specContentType` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SpecContentType`)`` Required. The type of the spec content. |
| `specContents` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_spec#Input.Schema.SpecContents`)`` Optional. The additional spec contents. |
| `createTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the spec content was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `updateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the spec content was last updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `labels` | `map (key: string, value: string)` Optional. The labels of the spec content e.g. specboost addon version. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |

### LabelsEntry

| JSON representation |
|---|
| ``` { "key": string, "value": string } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | `string` |

### Format

Enumeration of spec formats.

| Enums ||
|---|---|
| `FORMAT_UNSPECIFIED` | SpecFile type unspecified. |
| `OPEN_API_SPEC_2_0` | OpenAPI Spec v2.0. |
| `OPEN_API_SPEC_3_0` | OpenAPI Spec v3.0. |
| `OPEN_API_SPEC_3_1` | OpenAPI Spec v3.1. |

### Severity

Severity of the issue.

| Enums ||
|---|---|
| `SEVERITY_UNSPECIFIED` | Severity unspecified. |
| `SEVERITY_ERROR` | Severity error. |
| `SEVERITY_WARNING` | Severity warning. |
| `SEVERITY_INFO` | Severity info. |
| `SEVERITY_HINT` | Severity hint. |

### LintState

Lint state represents success or failure for linting.

| Enums ||
|---|---|
| `LINT_STATE_UNSPECIFIED` | Lint state unspecified. |
| `LINT_STATE_SUCCESS` | Linting was completed successfully. |
| `LINT_STATE_ERROR` | Linting encountered errors. |

### Linter

Enumeration of linter types.

| Enums ||
|---|---|
| `LINTER_UNSPECIFIED` | Linter type unspecified. |
| `SPECTRAL` | Linter type spectral. |
| `OTHER` | Linter type other. |

### ParsingMode

Specifies the parsing mode for API specifications during creation and update. - `RELAXED`: Parsing errors in the specification content do not fail the API call. - `STRICT`: Parsing errors in the specification content result in failure of the API call. If not specified, defaults to `RELAXED`.

| Enums ||
|---|---|
| `PARSING_MODE_UNSPECIFIED` | Defaults to `RELAXED`. |
| `RELAXED` | Parsing of the Spec on create and update is relaxed, meaning that parsing errors the spec contents will not fail the API call. |
| `STRICT` | Parsing of the Spec on create and update is strict, meaning that parsing errors in the spec contents will fail the API call. |

### SourceType

The possible types of the source.

| Enums ||
|---|---|
| `SOURCE_TYPE_UNSPECIFIED` | Source type not specified. |
| `PLUGIN` | Source type plugin. |

### SpecContentType

Enumerations of the spec content types. More values may be added in the future.

| Enums ||
|---|---|
| `SPEC_CONTENT_TYPE_UNSPECIFIED` | Unspecified spec content type. Defaults to spec content uploaded by the user. |
| `BOOSTED_SPEC_CONTENT` | The spec content type for boosted spec. |
| `GATEWAY_OPEN_API_SPEC` | The spec content type for OpenAPI spec. This enum is used for OpenAPI specs ingested via APIGEE X Gateway. |

### Tool Annotations

Destructive Hint: ❌ \| Idempotent Hint: ✅ \| Read Only Hint: ✅ \| Open World Hint: ❌